<?php

// Exit if accessed directly
if (!defined('ABSPATH')) {
    exit;
}

class TFL_Admin {


    protected $plugin_slug = 'themesflat_el_addons';

    public function __construct() {

        $this->includes();
        $this->init_hooks();

    }

    public function includes() {

        // load class admin ajax function
        require_once TFL_PLUGIN_DIR . 'admin/admin-ajax.php';

        /**
         * Classes responsible for displaying admin notices.
         */
        if (tfl_fs()->is_not_paying()) {

            require_once TFL_PLUGIN_DIR . 'admin/notices/admin-notice.php';

            require_once TFL_PLUGIN_DIR . 'admin/notices/admin-notice-rate.php';
        }

    }

    public function init_hooks() {

        // Build admin menu/pages
//        add_action('admin_menu', array($this, 'add_plugin_admin_menu'));

        add_action('admin_init', array($this, 'handle_external_redirects'), 1);

        // Load admin style sheet and JavaScript.
        add_action('admin_enqueue_scripts', array($this, 'enqueue_admin_scripts'));

        add_action('current_screen', array($this, 'remove_admin_notices'));


        /**
         * Notice: Rate plugin
         */
        if (tfl_fs()->is_not_paying()) {
            $rate = new TFL_Notice_Rate('rate', TFL_PLUGIN_DIR . 'admin/notices/templates/rate.php');

            add_action('load-plugins.php', array($rate, 'defer_first_time'));
            add_action('admin_notices', array($rate, 'display_notice'));
            add_action('admin_post_tfl_dismiss_notice', array($rate, 'dismiss_notice'));
        }

    }

    public function remove_admin_notices($screen) {

        // If this screen is Addons for Elementor plugin options page, remove annoying admin notices
        if (strpos($screen->id, $this->plugin_slug) !== false && strpos($screen->id, $this->plugin_slug . '_license') === false) {
            add_action('admin_notices', array(&$this, 'remove_notices_start'));
            add_action('admin_notices', array(&$this, 'remove_notices_end'), 999);
        }
    }

    public function remove_notices_start() {

        // Turn on output buffering
        ob_start();

    }

    public function remove_notices_end() {

        // Get current buffer contents and delete current output buffer
        $content = ob_get_contents();
        ob_clean();

    }

//    public function add_plugin_admin_menu() {
//
//        add_menu_page(
//            __('Themesflat Addons for Elementor', 'themesflat'),
//            __('Themesflat Addons', 'themesflat'),
//            'manage_options',
//            $this->plugin_slug,
//            array($this, 'display_settings_page'),
//            TFL_PLUGIN_URL . 'admin/assets/images/logo-shape16.png'
//        );
//
//        // add plugin settings submenu page
//        add_submenu_page(
//            $this->plugin_slug,
//            __('Widgets Settings', 'themesflat'),
//            __('Settings', 'themesflat'),
//            'manage_options',
//            $this->plugin_slug,
//            array($this, 'display_settings_page')
//        );
//
//        // add import/export submenu page
//        add_submenu_page(
//            $this->plugin_slug,
//            __('Widgets Documentation', 'themesflat'),
//            __('Documentation', 'themesflat'),
//            'manage_options',
//            $this->plugin_slug . '_documentation',
//            '__return_false',
//            null
//        );
//
//    }

    public function handle_external_redirects() {
        if (empty($_GET['page'])) {
            return;
        }

        if ($this->plugin_slug . '_documentation' === $_GET['page']) {
            wp_redirect('https://themesflatelementor.com/documentation/');
            die;
        }
    }

    public function display_settings_page() {

        require_once('views/admin-header.php');
        require_once('views/admin-banner2.php');
        require_once('views/settings.php');
        require_once('views/admin-footer.php');

    }

    public function enqueue_admin_scripts() {

        // Use minified libraries if TFL_SCRIPT_DEBUG is turned off
        $suffix = (defined('TFL_SCRIPT_DEBUG') && TFL_SCRIPT_DEBUG) ? '' : '.min';

        // get current admin screen
        $screen = get_current_screen();

        // If screen is a part of Addons for Elementor plugin options page
        if (strpos($screen->id, $this->plugin_slug) !== false) {

            wp_enqueue_script('jquery-ui-datepicker');

            wp_enqueue_script('wp-color-picker');
            wp_enqueue_style('wp-color-picker');

            wp_register_style('tfl-admin-styles', TFL_PLUGIN_URL . 'admin/assets/css/tfl-admin.css', array(), TFL_VERSION);
            wp_enqueue_style('tfl-admin-styles');

            wp_register_script('tfl-admin-scripts', TFL_PLUGIN_URL . 'admin/assets/js/tfl-admin' . $suffix . '.js', array(), TFL_VERSION, true);
            wp_enqueue_script('tfl-admin-scripts');

            wp_register_style('tfl-admin-page-styles', TFL_PLUGIN_URL . 'admin/assets/css/tfl-admin-page.css', array(), TFL_VERSION);
            wp_enqueue_style('tfl-admin-page-styles');
        }

    }

}

new TFL_Admin;